package io.scanbot.sdk.flutter.camera.detectorWrappers

import com.google.gson.JsonObject
import io.flutter.plugin.common.MethodCall
import io.scanbot.sdk.ScanbotSDK
import io.scanbot.sdk.camera.FrameHandler
import io.scanbot.sdk.flutter.Json
import java.text.SimpleDateFormat
import java.util.*

interface IDetectorWrapper {
    val scanbotSDK: ScanbotSDK
    fun attach(arguments: Json)

    fun detach()

    fun toggleContinuousFocus()

    fun flashEnabled(enabled: Boolean)

    fun getLicenseStatusJson(): JsonObject {
        val json = JsonObject()
        json.addProperty("isLicenseValid", scanbotSDK.licenseInfo.isValid)
        json.addProperty("status", scanbotSDK.licenseInfo.status.name)
        val time = scanbotSDK.licenseInfo.expirationDate?.time
        time?.let { date ->
            val sdf: SimpleDateFormat = SimpleDateFormat(
                "yyyy-MM-dd'T'HH:mm:ss.SSS",
                Locale.ENGLISH
            )
            sdf.timeZone = TimeZone.getTimeZone("UTC")
            json.addProperty("expirationDate", sdf.format(date))
        }
        val message = scanbotSDK.licenseInfo.licenseStatusMessage
        json.addProperty("message", message)
        return json
    }
}
