import Flutter
import UIKit
import ScanbotSDK

public class SwiftScanbotSdkPlugin: NSObject, FlutterPlugin {
    
    private let callHandler = SDKCallHandler()
    static var classicalCameraDetectorChannel: FlutterMethodChannel?
    static var cameraMethodChannel: FlutterMethodChannel?
    static var cameraFinderChannel: FlutterMethodChannel?
    
    static var onDispose: (() -> Void)?
    
    public static func register(with         registrar: FlutterPluginRegistrar) {
        let instance = SwiftScanbotSdkPlugin()
        
        let channel = FlutterMethodChannel(name: MethodChannelConstants.kScanbotMethodChannel, binaryMessenger:         registrar.messenger())
        registrar.addMethodCallDelegate(instance, channel: channel)
        
        let dataChannel = FlutterMethodChannel(name: MethodChannelConstants.kScanbotDataMethodChannel, binaryMessenger:         registrar.messenger())
        instance.callHandler.dataFormatterChannel = dataChannel
        registrar.addMethodCallDelegate(instance, channel: dataChannel)
        
        let classicalCameraDetectorChannel = FlutterMethodChannel(name: MethodChannelConstants.kClassicalCameraDetectorChannel, binaryMessenger:         registrar.messenger())
        self.classicalCameraDetectorChannel = classicalCameraDetectorChannel
        registrar.addMethodCallDelegate(instance, channel: classicalCameraDetectorChannel)
        
        let classicalCameraChannel = FlutterMethodChannel(name: MethodChannelConstants.kClassicalCameraChannel, binaryMessenger:         registrar.messenger())
        self.cameraMethodChannel = classicalCameraChannel
        registrar.addMethodCallDelegate(instance, channel: classicalCameraChannel)
        
        let classicalCameraFinderChannel = FlutterMethodChannel(name: MethodChannelConstants.kClassicalCameraFinderChannel, binaryMessenger:         registrar.messenger())
        self.cameraFinderChannel = classicalCameraFinderChannel
        registrar.addMethodCallDelegate(instance, channel: classicalCameraFinderChannel)
    }
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        let presenter = UIApplication.shared.windows.first?.rootViewController
        self.callHandler.handle(call: call, rootViewController: presenter, result: result)
    }
}
